import {
  StorageStatisticsSegmentDto,
  StorageStatisticsSegmentUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/StorageStatisticsSegmentDto";
import { UploadStatisticsMimeRecord } from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/UploadStatisticsMimeRecord";
import {
  BandwidthDto,
  BandwidthUnboxedDto
} from "@upload-io/upload-shared-iso/statistics/storage/dtos/shared/BandwidthDto";

export interface UploadStatisticsDto {
  all: StorageStatisticsSegmentDto;
  mime: UploadStatisticsMimeRecord<StorageStatisticsSegmentDto>;
  uploadBandwidth: BandwidthDto;
}

export interface UploadStatisticsUnboxedDto {
  all: StorageStatisticsSegmentUnboxedDto;
  mime: UploadStatisticsMimeRecord<StorageStatisticsSegmentUnboxedDto>;
  uploadBandwidth: BandwidthUnboxedDto;
}

export namespace UploadStatisticsDto {
  export const empty: UploadStatisticsDto = {
    all: StorageStatisticsSegmentDto.empty,
    mime: {
      audio: StorageStatisticsSegmentDto.empty,
      image: StorageStatisticsSegmentDto.empty,
      video: StorageStatisticsSegmentDto.empty,
      document: StorageStatisticsSegmentDto.empty,
      other: StorageStatisticsSegmentDto.empty
    },
    uploadBandwidth: BandwidthDto.empty
  };

  export function combine(left: UploadStatisticsDto, right: UploadStatisticsDto): UploadStatisticsDto {
    return {
      all: StorageStatisticsSegmentDto.combine(left.all, right.all),
      mime: {
        audio: StorageStatisticsSegmentDto.combine(left.mime.audio, right.mime.audio),
        image: StorageStatisticsSegmentDto.combine(left.mime.image, right.mime.image),
        video: StorageStatisticsSegmentDto.combine(left.mime.video, right.mime.video),
        document: StorageStatisticsSegmentDto.combine(left.mime.document, right.mime.document),
        other: StorageStatisticsSegmentDto.combine(left.mime.other, right.mime.other)
      },
      uploadBandwidth: BandwidthDto.combine(left.uploadBandwidth, right.uploadBandwidth)
    };
  }
}
